open Int32

let main () =
  let bigint = (int_to_int32 0x7fffffff) in
  let double5 = int_to_int32 0x50005 in
  let one = int_to_int32 1 in
  let neg1 =  lor32 (lsl32 bigint  1) one in
  let five1 = int_to_int32 0x5ffff in
  let lower1 = int_to_int32 0xffff in
  let upper1 = lsl32 lower1 16 in
  let zero = int_to_int32 0 in
  Printf.printf "bigint: %s\ndouble5: %s\none: %s\nneg1: %s\nfive1: %s\nlower1: %s\nupper1: %s\nzero: %s\n"
    (int32_to_string bigint) (int32_to_string double5) (int32_to_string one)
    (int32_to_string neg1)
    (int32_to_string five1)
    (int32_to_string lower1) (int32_to_string upper1) (int32_to_string zero);
  let t1 = succ32 (int_to_int32 0x7000c) in
  let t2 = succ32 (int_to_int32 0x7ffff) in
  let t3 = succ32 neg1 in
  let t4 = pred32 neg1 in
  let t5 = pred32 (int_to_int32 0x70000) in
  let t6 = pred32 (int_to_int32 0x7000c) in
  let t7 = pred32 (int_to_int32 0) in
  let t8 = double5 ++ double5 in
  let t9 = double5 ++ five1 in
  let t10 = double5 ++ neg1 in
  let t11 = five1 ++ five1 in
  let t12 = five1 ++ five1 in
  let t13 = upper1 ++ upper1 in
  let t14 = neg1 ++ neg1 in
  Printf.printf "t1: %s\nt2: %s\nt3: %s\nt4: %s\nt5: %s\nt6: %s\nt7: %s\n"
    (int32_to_string t1) (int32_to_string t2) (int32_to_string t3)
    (int32_to_string t4) (int32_to_string t5) (int32_to_string t6) (int32_to_string t7);
  Printf.printf "t8: %s\nt9: %s\nt10: %s\nt11: %s\nt12: %s\nt13: %s\nt14: %s\n"
    (int32_to_string t8) (int32_to_string t9) (int32_to_string t10) (int32_to_string t11)
    (int32_to_string t12) (int32_to_string t13) (int32_to_string t14);
  Printf.printf "max: %s\nmin: %s\n"
    (int32_to_string max_u_int32) (int32_to_string min_u_int32);
  let t15 = double5 *+ double5 in
  let t16 = double5 *+ zero in
  let t17 = neg1 *+ one in
  let t18 = neg1 *+ zero in
  let t19 = land32 neg1 zero in
  let t20 = land32 double5 neg1 in
  let t21 = land32 double5 five1 in
  let t22 = lxor32 neg1 zero in
  let t23 = lxor32 double5 neg1 in
  let t24 = lxor32 double5 five1 in
  let t25 = lnot32 neg1 in
  let t26 = lnot32 double5 in
  let t27 = lsl32 neg1 5 in
  let t28 = lsl32 double5 7 in
  let t29 = lsl32 double5 24 in
  let t30 = lsl32 double5 32 in
  let t31 = lsl32 double5 48 in
  let t32 = lsr32 neg1 5 in
  let t33 = lsr32 double5 7 in
  let t34 = lsr32 double5 24 in
  let t35 = lsr32 double5 32 in
  let t36 = lsr32 double5 48 in
  Printf.printf "t15: %s\nt16: %s\nt17: %s\nt18: %s\nt19: %s\n"
    (int32_to_string t15) (int32_to_string t16) (int32_to_string t17)
    (int32_to_string t18) (int32_to_string t19);
  Printf.printf "t20: %s\nt21: %s\nt22: %s\nt23: %s\nt24: %s\n"
    (int32_to_string t20) (int32_to_string t21) (int32_to_string t22)
    (int32_to_string t23) (int32_to_string t24);
  Printf.printf "t25: %s\nt26: %s\nt27: %s\nt28: %s\nt29: %s\n"
    (int32_to_string t25) (int32_to_string t26) (int32_to_string t27)
    (int32_to_string t28) (int32_to_string t29);
  Printf.printf "t30: %s\nt31: %s\nt32: %s\nt33: %s\nt34: %s\n"
    (int32_to_string t30) (int32_to_string t31) (int32_to_string t32)
    (int32_to_string t33) (int32_to_string t34);
  Printf.printf "t35: %s\nt36: %s\n"
    (int32_to_string t35) (int32_to_string t36)

let _ = main()
