open Safeloader.Nat
open Dsaprimes

(*let (q, p) = prime_gen 8;;

Printf.printf "q: %s\np: %s\n" (string_of_nat q) (string_of_nat p)*)

let ((p, q, alpha, y), a) = key_gen 8;;

Printf.printf "p\t%s\nq\t%s\nalpha\t%s\ny\t%s\na\t%s\n"
    (string_of_nat p) (string_of_nat q) (string_of_nat alpha)
    (string_of_nat y) (string_of_nat a); flush stdout

let message =
  "Now is the time for all good men to come to the aid of their party.";;

Printf.printf "about to sign\n"; flush stdout

let (r, s) = sign message (p, q, alpha, y) a (nat_of_int 0);;

Printf.printf "about to verify\n"; flush stdout;

if verify message (r, s) (p, q, alpha, y)
then begin
  Printf.printf "It worked\n";
  exit 0
end else begin
  Printf.printf "Ooops\n";
  exit 1
end

