type token =
    LOAD
  | EXEC
  | UNLOAD
  | STRING of (string)
  | EOL

open Parsing
let parse_error str = prerr_endline ("Unknown command: " ^ str)
(* Line 4, file cmds.ml *)
let yytransl_const = [|
  257 (* LOAD *);
  258 (* EXEC *);
  259 (* UNLOAD *);
  261 (* EOL *);
    0|]

let yytransl_block = [|
  260 (* STRING *);
    0|]

let yylhs = "\255\255\
\001\000\001\000\002\000\002\000\002\000\003\000\003\000\003\000\
\003\000\000\000"

let yylen = "\002\000\
\002\000\003\000\002\000\003\000\002\000\001\000\001\000\001\000\
\001\000\002\000"

let yydefred = "\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\010\000\000\000\
\000\000\007\000\008\000\009\000\006\000\003\000\000\000\005\000\
\001\000\002\000\004\000"

let yydgoto = "\002\000\
\007\000\008\000\014\000"

let yysindex = "\010\000\
\002\255\000\000\007\255\005\255\005\255\005\255\000\000\008\255\
\002\255\000\000\000\000\000\000\000\000\000\000\005\255\000\000\
\000\000\000\000\000\000"

let yyrindex = "\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000"

let yygindex = "\000\000\
\005\000\000\000\251\255"

let yytablesize = 14
let yytable = "\015\000\
\016\000\003\000\004\000\005\000\006\000\010\000\011\000\012\000\
\013\000\019\000\001\000\009\000\017\000\018\000"

let yycheck = "\005\000\
\006\000\000\001\001\001\002\001\003\001\001\001\002\001\003\001\
\004\001\015\000\001\000\005\001\005\001\009\000"

let yyact = [|
  (fun _ -> failwith "parser")
(* Rule 1, file cmds.mly, line 13 *)
; (fun parser_env ->
	let dollar__1 = (peek_val parser_env 1 : 'expr) in
	Obj.repr(( dollar__1 ) : Safeloader.Func.operation))
(* Rule 2, file cmds.mly, line 14 *)
; (fun parser_env ->
	let dollar__3 = (peek_val parser_env 0 : Safeloader.Func.operation) in
	Obj.repr(( dollar__3 ) : Safeloader.Func.operation))
(* Rule 3, file cmds.mly, line 18 *)
; (fun parser_env ->
	let dollar__2 = (peek_val parser_env 0 : 'anystr) in
	Obj.repr(( Safeloader.Func.LOAD(dollar__2) ) : 'expr))
(* Rule 4, file cmds.mly, line 19 *)
; (fun parser_env ->
	let dollar__2 = (peek_val parser_env 1 : 'anystr) in
	let dollar__3 = (peek_val parser_env 0 : 'anystr) in
	Obj.repr(( Safeloader.Func.EXEC(dollar__2,dollar__3) ) : 'expr))
(* Rule 5, file cmds.mly, line 20 *)
; (fun parser_env ->
	let dollar__2 = (peek_val parser_env 0 : 'anystr) in
	Obj.repr(( Safeloader.Func.UNLOAD(dollar__2) ) : 'expr))
(* Rule 6, file cmds.mly, line 24 *)
; (fun parser_env ->
	let dollar__1 = (peek_val parser_env 0 : string) in
	Obj.repr(( dollar__1 ) : 'anystr))
(* Rule 7, file cmds.mly, line 25 *)
; (fun parser_env ->
	Obj.repr(( "load" ) : 'anystr))
(* Rule 8, file cmds.mly, line 26 *)
; (fun parser_env ->
	Obj.repr(( "exec" ) : 'anystr))
(* Rule 9, file cmds.mly, line 27 *)
; (fun parser_env ->
	Obj.repr(( "unload" ) : 'anystr))
(* Entry main *)
; (fun parser_env -> raise (YYexit (peek_val parser_env 0)))
|]
let yytables =
  { actions=yyact;
    transl_const=yytransl_const;
    transl_block=yytransl_block;
    lhs=yylhs;
    len=yylen;
    defred=yydefred;
    dgoto=yydgoto;
    sindex=yysindex;
    rindex=yyrindex;
    gindex=yygindex;
    tablesize=yytablesize;
    table=yytable;
    check=yycheck;
    error_function=parse_error }
let main lexfun lexbuf = yyparse yytables 1 lexfun lexbuf
