%{
let parse_error str = prerr_endline ("Unknown command: " ^ str)
%}
%token LOAD
%token EXEC
%token UNLOAD
%token <string> STRING
%token EOL
%start main
%type <Safeloader.Func.operation> main
%%
main:
    expr EOL		{ $1 }
  | error EOL main	{ $3 }		
;

expr:
    LOAD anystr		{ Safeloader.Func.LOAD($2) }
  | EXEC anystr	anystr	{ Safeloader.Func.EXEC($2,$3) }
  | UNLOAD anystr	{ Safeloader.Func.UNLOAD($2) }
;

anystr:
    STRING		{ $1 }
  | LOAD		{ "load" }
  | EXEC		{ "exec" }
  | UNLOAD		{ "unload" }
;
