module type IPADDR =
    sig
      type ip_addr

      val to_unix : ip_addr -> Unix.inet_addr
      val from_unix : Unix.inet_addr -> ip_addr

      val to_string : ip_addr -> string
      val from_string : string -> ip_addr
    end
