open Safeloader

type ipaddr = int * int * int * int

let ipconfig_hash = Hashtbl.create 23

let make_ip_addr addr =
  let (a, b, c, d) = addr in
  Printf.sprintf "%c%c%c%c" (Char.chr a) (Char.chr b) (Char.chr c) (Char.chr d)

let _ = Hashtbl.add ipconfig_hash "oilhead.cis.upenn.edu"
  [ ("eth0",make_ip_addr (158,130,7,120));
    ("eth1",make_ip_addr (158,130,7,121));
    ("eth2",make_ip_addr (158,130,7,122));
    ("eth3",make_ip_addr (158,130,7,123))]

let _ = Hashtbl.add ipconfig_hash "kamagarini.cis.upenn.edu"
  [ ("eth0",make_ip_addr (158,130,6,143)) ]
