{
open Cmds
exception Eof
} 
rule token = parse
    [' ' '\t']		{ token lexbuf } (* skip blanks *)
  | ['\n' ]		{ EOL }
  | "load"		{ LOAD }
  | "exec"		{ EXEC }
  | "unload"		{ UNLOAD }
  | [^' ' '\t' '\n']+   { STRING(Lexing.lexeme lexbuf) }
  | eof                 { raise Eof }
