(* log.mli
 * 
 * interface for log usage
 *
 * $Id: log_priv.mli,v 1.1 1997/12/05 19:16:37 mwh Exp $
 * $Revision: 1.1 $
 *
 *)

val set_log_file : string -> unit

val log_msg : string -> int

(*
 * $Log: log_priv.mli,v $
# Revision 1.1  1997/12/05  19:16:37  mwh
# Added some core files for use between PLAN and the rest of the loader.
# Modified the makefile to be able to link in PLAN as a privileged
# service, and expose some of its interface.  Changed notion of routing
# function to be fun : activehost -> activehost.
#
# Revision 1.2  1997/12/05  16:32:34  jonm
# Added -l command line argument to specify log file; also added evalDest
# support to daemon.ml so that we only evaluated packets for which we are the
# specified evalDest.
#
 *)
