(***********************************************************************)
(*                                                                     *)
(*                           Objective Caml                            *)
(*                                                                     *)
(*         Xavier Leroy and Damien Doligez, INRIA Rocquencourt         *)
(*                                                                     *)
(*  Copyright 1996 Institut National de Recherche en Informatique et   *)
(*  Automatique.  Distributed only by permission.                      *)
(*                                                                     *)
(***********************************************************************)

(* $Id: mutex.ml,v 1.1 1998/01/06 03:07:32 salex Exp $ *)

module Safemutex = struct
type t = Mutex.t

let create = Mutex.create

let lock = Mutex.lock

let try_lock = Mutex.try_lock

let unlock = Mutex.unlock
end
