(* 
 * $Id: pland.mli,v 1.1 1998/01/14 16:02:16 mwh Exp $
 * $Revision: 1.1 $
 *
 * This defines the bridge-visible interface to the PLAN packet handler
 *
 *)

module Install_svc_impl:sig
  val register_svcs : unit -> unit
end

module Pland:sig
(* This function starts the processing of plan packets.  It will not
   return unless the PLAN network interface is closed.

   start_plan v p ifile

   will set the verbose mode to v, the receiving Planport p, and
   the interface file to ifile
*)

  val start_plan : bool * int * string -> unit
end

