open Thread

let usage name =
  Printf.printf "usage : %s msg num\n" name;
  Pervasives.exit 1;
  ("blah",1)

let proc_args argv =
  let argc = Array.length argv in
  if (argc < 3) then
    usage(argv.(0))
  else
    (argv.(1),int_of_string(argv.(2)))

let go () =
  let (msg,num) = proc_args Sys.argv in
  let i = ref 1 in
  let sfd = Unix.socket Unix.PF_UNIX Unix.SOCK_STREAM 0 in
  Unix.connect sfd (Unix.ADDR_UNIX "/tmp/planin");
  while (!i<num) do
    Unix.send sfd msg 0 (String.length msg) [];
    Thread.delay 5.0;
    i := !i + 1
  done;
  Unix.close sfd;;

go();;
