open Safeloader
open Wf
open Safeunix
open Nat
open Dsaprimes
open Cryptomath
open An
open Sha1
open Saneproto
open An_marshal

(* Delivery function, first packet *)
let deliver_first argstring =
  let { code=code; data=certlist; func=func} = decode argstring 0 in
  Saneproto.receive_first (Saneproto.decode_certificates certlist) code;
  ""
      
(* Delivery function, second packet *)
let deliver_second argstring =
  let { code=code; data=certlist; func=func} = decode argstring 0 in
  Saneproto.receive_second(Saneproto.decode_certificates certlist) code;
  ""
    
(* Delivery function, third packet *)
let deliver_third argstring =
  let { code=code; data=certlist; func=func} = decode argstring 0 in
  Saneproto.receive_third (Saneproto.decode_certificates certlist)

let _ = Func.register "deliver_first" deliver_first
let _ = Func.register "deliver_second" deliver_second
let _ = Func.register "deliver_third" deliver_third
