open Safeloader
open Wf
open An_marshal

let udp_decode str =
  ((String.sub str 0 11), (String.sub str 11 ((String.length str) - 11)))

let udp_out arg_string =
  let {code=code; data=datastr; func=func} = decode arg_string 0 in
  let (fin, payload) = udp_decode datastr in
  let finish = String.sub fin 0 (min (String.index fin ' ') 11) in
  if  (finish = An.getAddress())
  then begin
    An.pktinc(); payload
  end else begin
(*
    send_wf (Route.get_route finish)
    {do_forward=true; type_id=20} [] "udp_out" code datastr;
    "forwarded"
*)
    "should forward, but we're testing whether we are dropping"
  end

let _ = Func.register "udp_out" udp_out
