open Sha1

let main () =
  let ctx = sha1init () in
  let s = String.make 1000000 'a' in
  sha1update ctx s;
  let digest = sha1final ctx in
  for i = 0 to 4 do
    for j = 0 to 3 do
      Printf.printf "%02X" (Char.code (digest.[i*4+j]))
    done;
    Printf.printf " "
  done;
  Printf.printf "\n"

let _ = Printexc.catch main ()
