#include <caml/mlvalues.h>
#include <caml/alloc.h>
#include <caml/memory.h>

static inline unsigned int rpcc(void)
{
    unsigned int result;

    asm volatile ("rpcc %0" : "r="(result));
    return result;
}

value get_time(void)
{
     static unsigned long top = 0;
     static unsigned long last = 0;
     unsigned long a;

     a = rpcc();
     if (a < last) top += 0x100000000L;
     last = a;
     /* assume 533Mhz Alpha */
     return copy_double((double)(a + top) / (double)533000000);
}
